package contacts

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"
	"time"

	"golang.org/x/net/context"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/swag"

	strfmt "github.com/go-openapi/strfmt"
)

// NewPostCharactersCharacterIDContactsParams creates a new PostCharactersCharacterIDContactsParams object
// with the default values initialized.
func NewPostCharactersCharacterIDContactsParams() *PostCharactersCharacterIDContactsParams {
	var (
		datasourceDefault = string("tranquility")
		labelIDDefault    = int64(0)
		watchedDefault    = bool(false)
	)
	return &PostCharactersCharacterIDContactsParams{
		Datasource: &datasourceDefault,
		LabelID:    &labelIDDefault,
		Watched:    &watchedDefault,

		timeout: cr.DefaultTimeout,
	}
}

// NewPostCharactersCharacterIDContactsParamsWithTimeout creates a new PostCharactersCharacterIDContactsParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewPostCharactersCharacterIDContactsParamsWithTimeout(timeout time.Duration) *PostCharactersCharacterIDContactsParams {
	var (
		datasourceDefault = string("tranquility")
		labelIDDefault    = int64(0)
		watchedDefault    = bool(false)
	)
	return &PostCharactersCharacterIDContactsParams{
		Datasource: &datasourceDefault,
		LabelID:    &labelIDDefault,
		Watched:    &watchedDefault,

		timeout: timeout,
	}
}

// NewPostCharactersCharacterIDContactsParamsWithContext creates a new PostCharactersCharacterIDContactsParams object
// with the default values initialized, and the ability to set a context for a request
func NewPostCharactersCharacterIDContactsParamsWithContext(ctx context.Context) *PostCharactersCharacterIDContactsParams {
	var (
		datasourceDefault = string("tranquility")
		labelIdDefault    = int64(0)
		watchedDefault    = bool(false)
	)
	return &PostCharactersCharacterIDContactsParams{
		Datasource: &datasourceDefault,
		LabelID:    &labelIdDefault,
		Watched:    &watchedDefault,

		Context: ctx,
	}
}

/*PostCharactersCharacterIDContactsParams contains all the parameters to send to the API endpoint
for the post characters character id contacts operation typically these are written to a http.Request
*/
type PostCharactersCharacterIDContactsParams struct {

	/*CharacterID
	  ID for a character

	*/
	CharacterID int32
	/*ContactIds
	  A list of contacts to add

	*/
	ContactIds []int32
	/*Datasource
	  The server name you would like data from

	*/
	Datasource *string
	/*LabelID
	  Add a custom label to the new contact

	*/
	LabelID *int64
	/*Standing
	  Standing for the new contact

	*/
	Standing float32
	/*Watched
	  Whether the new contact should be watched, note this is only effective on characters

	*/
	Watched *bool

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the post characters character id contacts params
func (o *PostCharactersCharacterIDContactsParams) WithTimeout(timeout time.Duration) *PostCharactersCharacterIDContactsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the post characters character id contacts params
func (o *PostCharactersCharacterIDContactsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the post characters character id contacts params
func (o *PostCharactersCharacterIDContactsParams) WithContext(ctx context.Context) *PostCharactersCharacterIDContactsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the post characters character id contacts params
func (o *PostCharactersCharacterIDContactsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithCharacterID adds the characterID to the post characters character id contacts params
func (o *PostCharactersCharacterIDContactsParams) WithCharacterID(characterID int32) *PostCharactersCharacterIDContactsParams {
	o.SetCharacterID(characterID)
	return o
}

// SetCharacterID adds the characterId to the post characters character id contacts params
func (o *PostCharactersCharacterIDContactsParams) SetCharacterID(characterID int32) {
	o.CharacterID = characterID
}

// WithContactIds adds the contactIds to the post characters character id contacts params
func (o *PostCharactersCharacterIDContactsParams) WithContactIds(contactIds []int32) *PostCharactersCharacterIDContactsParams {
	o.SetContactIds(contactIds)
	return o
}

// SetContactIds adds the contactIds to the post characters character id contacts params
func (o *PostCharactersCharacterIDContactsParams) SetContactIds(contactIds []int32) {
	o.ContactIds = contactIds
}

// WithDatasource adds the datasource to the post characters character id contacts params
func (o *PostCharactersCharacterIDContactsParams) WithDatasource(datasource *string) *PostCharactersCharacterIDContactsParams {
	o.SetDatasource(datasource)
	return o
}

// SetDatasource adds the datasource to the post characters character id contacts params
func (o *PostCharactersCharacterIDContactsParams) SetDatasource(datasource *string) {
	o.Datasource = datasource
}

// WithLabelID adds the labelID to the post characters character id contacts params
func (o *PostCharactersCharacterIDContactsParams) WithLabelID(labelID *int64) *PostCharactersCharacterIDContactsParams {
	o.SetLabelID(labelID)
	return o
}

// SetLabelID adds the labelId to the post characters character id contacts params
func (o *PostCharactersCharacterIDContactsParams) SetLabelID(labelID *int64) {
	o.LabelID = labelID
}

// WithStanding adds the standing to the post characters character id contacts params
func (o *PostCharactersCharacterIDContactsParams) WithStanding(standing float32) *PostCharactersCharacterIDContactsParams {
	o.SetStanding(standing)
	return o
}

// SetStanding adds the standing to the post characters character id contacts params
func (o *PostCharactersCharacterIDContactsParams) SetStanding(standing float32) {
	o.Standing = standing
}

// WithWatched adds the watched to the post characters character id contacts params
func (o *PostCharactersCharacterIDContactsParams) WithWatched(watched *bool) *PostCharactersCharacterIDContactsParams {
	o.SetWatched(watched)
	return o
}

// SetWatched adds the watched to the post characters character id contacts params
func (o *PostCharactersCharacterIDContactsParams) SetWatched(watched *bool) {
	o.Watched = watched
}

// WriteToRequest writes these params to a swagger request
func (o *PostCharactersCharacterIDContactsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	r.SetTimeout(o.timeout)
	var res []error

	// path param character_id
	if err := r.SetPathParam("character_id", swag.FormatInt32(o.CharacterID)); err != nil {
		return err
	}

	if err := r.SetBodyParam(o.ContactIds); err != nil {
		return err
	}

	if o.Datasource != nil {

		// query param datasource
		var qrDatasource string
		if o.Datasource != nil {
			qrDatasource = *o.Datasource
		}
		qDatasource := qrDatasource
		if qDatasource != "" {
			if err := r.SetQueryParam("datasource", qDatasource); err != nil {
				return err
			}
		}

	}

	if o.LabelID != nil {

		// query param label_id
		var qrLabelID int64
		if o.LabelID != nil {
			qrLabelID = *o.LabelID
		}
		qLabelID := swag.FormatInt64(qrLabelID)
		if qLabelID != "" {
			if err := r.SetQueryParam("label_id", qLabelID); err != nil {
				return err
			}
		}

	}

	// query param standing
	qrStanding := o.Standing
	qStanding := swag.FormatFloat32(qrStanding)
	if qStanding != "" {
		if err := r.SetQueryParam("standing", qStanding); err != nil {
			return err
		}
	}

	if o.Watched != nil {

		// query param watched
		var qrWatched bool
		if o.Watched != nil {
			qrWatched = *o.Watched
		}
		qWatched := swag.FormatBool(qrWatched)
		if qWatched != "" {
			if err := r.SetQueryParam("watched", qWatched); err != nil {
				return err
			}
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
