package fleets

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"
	"time"

	"golang.org/x/net/context"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/swag"

	strfmt "github.com/go-openapi/strfmt"
)

// NewPostFleetsFleetIDMembersParams creates a new PostFleetsFleetIDMembersParams object
// with the default values initialized.
func NewPostFleetsFleetIDMembersParams() *PostFleetsFleetIDMembersParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &PostFleetsFleetIDMembersParams{
		Datasource: &datasourceDefault,

		timeout: cr.DefaultTimeout,
	}
}

// NewPostFleetsFleetIDMembersParamsWithTimeout creates a new PostFleetsFleetIDMembersParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewPostFleetsFleetIDMembersParamsWithTimeout(timeout time.Duration) *PostFleetsFleetIDMembersParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &PostFleetsFleetIDMembersParams{
		Datasource: &datasourceDefault,

		timeout: timeout,
	}
}

// NewPostFleetsFleetIDMembersParamsWithContext creates a new PostFleetsFleetIDMembersParams object
// with the default values initialized, and the ability to set a context for a request
func NewPostFleetsFleetIDMembersParamsWithContext(ctx context.Context) *PostFleetsFleetIDMembersParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &PostFleetsFleetIDMembersParams{
		Datasource: &datasourceDefault,

		Context: ctx,
	}
}

/*PostFleetsFleetIDMembersParams contains all the parameters to send to the API endpoint
for the post fleets fleet id members operation typically these are written to a http.Request
*/
type PostFleetsFleetIDMembersParams struct {

	/*Datasource
	  The server name you would like data from

	*/
	Datasource *string
	/*FleetID
	  ID for a fleet

	*/
	FleetID int64
	/*Invitation
	  Details of the invitation

	*/
	Invitation PostFleetsFleetIDMembersBody

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the post fleets fleet id members params
func (o *PostFleetsFleetIDMembersParams) WithTimeout(timeout time.Duration) *PostFleetsFleetIDMembersParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the post fleets fleet id members params
func (o *PostFleetsFleetIDMembersParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the post fleets fleet id members params
func (o *PostFleetsFleetIDMembersParams) WithContext(ctx context.Context) *PostFleetsFleetIDMembersParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the post fleets fleet id members params
func (o *PostFleetsFleetIDMembersParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithDatasource adds the datasource to the post fleets fleet id members params
func (o *PostFleetsFleetIDMembersParams) WithDatasource(datasource *string) *PostFleetsFleetIDMembersParams {
	o.SetDatasource(datasource)
	return o
}

// SetDatasource adds the datasource to the post fleets fleet id members params
func (o *PostFleetsFleetIDMembersParams) SetDatasource(datasource *string) {
	o.Datasource = datasource
}

// WithFleetID adds the fleetID to the post fleets fleet id members params
func (o *PostFleetsFleetIDMembersParams) WithFleetID(fleetID int64) *PostFleetsFleetIDMembersParams {
	o.SetFleetID(fleetID)
	return o
}

// SetFleetID adds the fleetId to the post fleets fleet id members params
func (o *PostFleetsFleetIDMembersParams) SetFleetID(fleetID int64) {
	o.FleetID = fleetID
}

// WithInvitation adds the invitation to the post fleets fleet id members params
func (o *PostFleetsFleetIDMembersParams) WithInvitation(invitation PostFleetsFleetIDMembersBody) *PostFleetsFleetIDMembersParams {
	o.SetInvitation(invitation)
	return o
}

// SetInvitation adds the invitation to the post fleets fleet id members params
func (o *PostFleetsFleetIDMembersParams) SetInvitation(invitation PostFleetsFleetIDMembersBody) {
	o.Invitation = invitation
}

// WriteToRequest writes these params to a swagger request
func (o *PostFleetsFleetIDMembersParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	r.SetTimeout(o.timeout)
	var res []error

	if o.Datasource != nil {

		// query param datasource
		var qrDatasource string
		if o.Datasource != nil {
			qrDatasource = *o.Datasource
		}
		qDatasource := qrDatasource
		if qDatasource != "" {
			if err := r.SetQueryParam("datasource", qDatasource); err != nil {
				return err
			}
		}

	}

	// path param fleet_id
	if err := r.SetPathParam("fleet_id", swag.FormatInt64(o.FleetID)); err != nil {
		return err
	}

	if err := r.SetBodyParam(o.Invitation); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
