package fleets

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"
	"time"

	"golang.org/x/net/context"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/swag"

	strfmt "github.com/go-openapi/strfmt"
)

// NewPostFleetsFleetIDWingsWingIDSquadsParams creates a new PostFleetsFleetIDWingsWingIDSquadsParams object
// with the default values initialized.
func NewPostFleetsFleetIDWingsWingIDSquadsParams() *PostFleetsFleetIDWingsWingIDSquadsParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &PostFleetsFleetIDWingsWingIDSquadsParams{
		Datasource: &datasourceDefault,

		timeout: cr.DefaultTimeout,
	}
}

// NewPostFleetsFleetIDWingsWingIDSquadsParamsWithTimeout creates a new PostFleetsFleetIDWingsWingIDSquadsParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewPostFleetsFleetIDWingsWingIDSquadsParamsWithTimeout(timeout time.Duration) *PostFleetsFleetIDWingsWingIDSquadsParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &PostFleetsFleetIDWingsWingIDSquadsParams{
		Datasource: &datasourceDefault,

		timeout: timeout,
	}
}

// NewPostFleetsFleetIDWingsWingIDSquadsParamsWithContext creates a new PostFleetsFleetIDWingsWingIDSquadsParams object
// with the default values initialized, and the ability to set a context for a request
func NewPostFleetsFleetIDWingsWingIDSquadsParamsWithContext(ctx context.Context) *PostFleetsFleetIDWingsWingIDSquadsParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &PostFleetsFleetIDWingsWingIDSquadsParams{
		Datasource: &datasourceDefault,

		Context: ctx,
	}
}

/*PostFleetsFleetIDWingsWingIDSquadsParams contains all the parameters to send to the API endpoint
for the post fleets fleet id wings wing id squads operation typically these are written to a http.Request
*/
type PostFleetsFleetIDWingsWingIDSquadsParams struct {

	/*Datasource
	  The server name you would like data from

	*/
	Datasource *string
	/*FleetID
	  ID for a fleet

	*/
	FleetID int64
	/*WingID
	  The wing_id to create squad in

	*/
	WingID int64

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the post fleets fleet id wings wing id squads params
func (o *PostFleetsFleetIDWingsWingIDSquadsParams) WithTimeout(timeout time.Duration) *PostFleetsFleetIDWingsWingIDSquadsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the post fleets fleet id wings wing id squads params
func (o *PostFleetsFleetIDWingsWingIDSquadsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the post fleets fleet id wings wing id squads params
func (o *PostFleetsFleetIDWingsWingIDSquadsParams) WithContext(ctx context.Context) *PostFleetsFleetIDWingsWingIDSquadsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the post fleets fleet id wings wing id squads params
func (o *PostFleetsFleetIDWingsWingIDSquadsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithDatasource adds the datasource to the post fleets fleet id wings wing id squads params
func (o *PostFleetsFleetIDWingsWingIDSquadsParams) WithDatasource(datasource *string) *PostFleetsFleetIDWingsWingIDSquadsParams {
	o.SetDatasource(datasource)
	return o
}

// SetDatasource adds the datasource to the post fleets fleet id wings wing id squads params
func (o *PostFleetsFleetIDWingsWingIDSquadsParams) SetDatasource(datasource *string) {
	o.Datasource = datasource
}

// WithFleetID adds the fleetID to the post fleets fleet id wings wing id squads params
func (o *PostFleetsFleetIDWingsWingIDSquadsParams) WithFleetID(fleetID int64) *PostFleetsFleetIDWingsWingIDSquadsParams {
	o.SetFleetID(fleetID)
	return o
}

// SetFleetID adds the fleetId to the post fleets fleet id wings wing id squads params
func (o *PostFleetsFleetIDWingsWingIDSquadsParams) SetFleetID(fleetID int64) {
	o.FleetID = fleetID
}

// WithWingID adds the wingID to the post fleets fleet id wings wing id squads params
func (o *PostFleetsFleetIDWingsWingIDSquadsParams) WithWingID(wingID int64) *PostFleetsFleetIDWingsWingIDSquadsParams {
	o.SetWingID(wingID)
	return o
}

// SetWingID adds the wingId to the post fleets fleet id wings wing id squads params
func (o *PostFleetsFleetIDWingsWingIDSquadsParams) SetWingID(wingID int64) {
	o.WingID = wingID
}

// WriteToRequest writes these params to a swagger request
func (o *PostFleetsFleetIDWingsWingIDSquadsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	r.SetTimeout(o.timeout)
	var res []error

	if o.Datasource != nil {

		// query param datasource
		var qrDatasource string
		if o.Datasource != nil {
			qrDatasource = *o.Datasource
		}
		qDatasource := qrDatasource
		if qDatasource != "" {
			if err := r.SetQueryParam("datasource", qDatasource); err != nil {
				return err
			}
		}

	}

	// path param fleet_id
	if err := r.SetPathParam("fleet_id", swag.FormatInt64(o.FleetID)); err != nil {
		return err
	}

	// path param wing_id
	if err := r.SetPathParam("wing_id", swag.FormatInt64(o.WingID)); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
