package fleets

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"
	"time"

	"golang.org/x/net/context"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/swag"

	strfmt "github.com/go-openapi/strfmt"
)

// NewPutFleetsFleetIDWingsWingIDParams creates a new PutFleetsFleetIDWingsWingIDParams object
// with the default values initialized.
func NewPutFleetsFleetIDWingsWingIDParams() *PutFleetsFleetIDWingsWingIDParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &PutFleetsFleetIDWingsWingIDParams{
		Datasource: &datasourceDefault,

		timeout: cr.DefaultTimeout,
	}
}

// NewPutFleetsFleetIDWingsWingIDParamsWithTimeout creates a new PutFleetsFleetIDWingsWingIDParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewPutFleetsFleetIDWingsWingIDParamsWithTimeout(timeout time.Duration) *PutFleetsFleetIDWingsWingIDParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &PutFleetsFleetIDWingsWingIDParams{
		Datasource: &datasourceDefault,

		timeout: timeout,
	}
}

// NewPutFleetsFleetIDWingsWingIDParamsWithContext creates a new PutFleetsFleetIDWingsWingIDParams object
// with the default values initialized, and the ability to set a context for a request
func NewPutFleetsFleetIDWingsWingIDParamsWithContext(ctx context.Context) *PutFleetsFleetIDWingsWingIDParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &PutFleetsFleetIDWingsWingIDParams{
		Datasource: &datasourceDefault,

		Context: ctx,
	}
}

/*PutFleetsFleetIDWingsWingIDParams contains all the parameters to send to the API endpoint
for the put fleets fleet id wings wing id operation typically these are written to a http.Request
*/
type PutFleetsFleetIDWingsWingIDParams struct {

	/*Datasource
	  The server name you would like data from

	*/
	Datasource *string
	/*FleetID
	  ID for a fleet

	*/
	FleetID int64
	/*Naming
	  New name of the wing

	*/
	Naming PutFleetsFleetIDWingsWingIDBody
	/*WingID
	  The wing to rename

	*/
	WingID int64

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the put fleets fleet id wings wing id params
func (o *PutFleetsFleetIDWingsWingIDParams) WithTimeout(timeout time.Duration) *PutFleetsFleetIDWingsWingIDParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the put fleets fleet id wings wing id params
func (o *PutFleetsFleetIDWingsWingIDParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the put fleets fleet id wings wing id params
func (o *PutFleetsFleetIDWingsWingIDParams) WithContext(ctx context.Context) *PutFleetsFleetIDWingsWingIDParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the put fleets fleet id wings wing id params
func (o *PutFleetsFleetIDWingsWingIDParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithDatasource adds the datasource to the put fleets fleet id wings wing id params
func (o *PutFleetsFleetIDWingsWingIDParams) WithDatasource(datasource *string) *PutFleetsFleetIDWingsWingIDParams {
	o.SetDatasource(datasource)
	return o
}

// SetDatasource adds the datasource to the put fleets fleet id wings wing id params
func (o *PutFleetsFleetIDWingsWingIDParams) SetDatasource(datasource *string) {
	o.Datasource = datasource
}

// WithFleetID adds the fleetID to the put fleets fleet id wings wing id params
func (o *PutFleetsFleetIDWingsWingIDParams) WithFleetID(fleetID int64) *PutFleetsFleetIDWingsWingIDParams {
	o.SetFleetID(fleetID)
	return o
}

// SetFleetID adds the fleetId to the put fleets fleet id wings wing id params
func (o *PutFleetsFleetIDWingsWingIDParams) SetFleetID(fleetID int64) {
	o.FleetID = fleetID
}

// WithNaming adds the naming to the put fleets fleet id wings wing id params
func (o *PutFleetsFleetIDWingsWingIDParams) WithNaming(naming PutFleetsFleetIDWingsWingIDBody) *PutFleetsFleetIDWingsWingIDParams {
	o.SetNaming(naming)
	return o
}

// SetNaming adds the naming to the put fleets fleet id wings wing id params
func (o *PutFleetsFleetIDWingsWingIDParams) SetNaming(naming PutFleetsFleetIDWingsWingIDBody) {
	o.Naming = naming
}

// WithWingID adds the wingID to the put fleets fleet id wings wing id params
func (o *PutFleetsFleetIDWingsWingIDParams) WithWingID(wingID int64) *PutFleetsFleetIDWingsWingIDParams {
	o.SetWingID(wingID)
	return o
}

// SetWingID adds the wingId to the put fleets fleet id wings wing id params
func (o *PutFleetsFleetIDWingsWingIDParams) SetWingID(wingID int64) {
	o.WingID = wingID
}

// WriteToRequest writes these params to a swagger request
func (o *PutFleetsFleetIDWingsWingIDParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	r.SetTimeout(o.timeout)
	var res []error

	if o.Datasource != nil {

		// query param datasource
		var qrDatasource string
		if o.Datasource != nil {
			qrDatasource = *o.Datasource
		}
		qDatasource := qrDatasource
		if qDatasource != "" {
			if err := r.SetQueryParam("datasource", qDatasource); err != nil {
				return err
			}
		}

	}

	// path param fleet_id
	if err := r.SetPathParam("fleet_id", swag.FormatInt64(o.FleetID)); err != nil {
		return err
	}

	if err := r.SetBodyParam(o.Naming); err != nil {
		return err
	}

	// path param wing_id
	if err := r.SetPathParam("wing_id", swag.FormatInt64(o.WingID)); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
