package user_interface

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"
	"time"

	"golang.org/x/net/context"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/swag"

	strfmt "github.com/go-openapi/strfmt"
)

// NewPostUIOpenwindowMarketdetailsParams creates a new PostUIOpenwindowMarketdetailsParams object
// with the default values initialized.
func NewPostUIOpenwindowMarketdetailsParams() *PostUIOpenwindowMarketdetailsParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &PostUIOpenwindowMarketdetailsParams{
		Datasource: &datasourceDefault,

		timeout: cr.DefaultTimeout,
	}
}

// NewPostUIOpenwindowMarketdetailsParamsWithTimeout creates a new PostUIOpenwindowMarketdetailsParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewPostUIOpenwindowMarketdetailsParamsWithTimeout(timeout time.Duration) *PostUIOpenwindowMarketdetailsParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &PostUIOpenwindowMarketdetailsParams{
		Datasource: &datasourceDefault,

		timeout: timeout,
	}
}

// NewPostUIOpenwindowMarketdetailsParamsWithContext creates a new PostUIOpenwindowMarketdetailsParams object
// with the default values initialized, and the ability to set a context for a request
func NewPostUIOpenwindowMarketdetailsParamsWithContext(ctx context.Context) *PostUIOpenwindowMarketdetailsParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &PostUIOpenwindowMarketdetailsParams{
		Datasource: &datasourceDefault,

		Context: ctx,
	}
}

/*PostUIOpenwindowMarketdetailsParams contains all the parameters to send to the API endpoint
for the post ui openwindow marketdetails operation typically these are written to a http.Request
*/
type PostUIOpenwindowMarketdetailsParams struct {

	/*Datasource
	  The server name you would like data from

	*/
	Datasource *string
	/*TypeID
	  The item type to open in market window

	*/
	TypeID int32

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the post ui openwindow marketdetails params
func (o *PostUIOpenwindowMarketdetailsParams) WithTimeout(timeout time.Duration) *PostUIOpenwindowMarketdetailsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the post ui openwindow marketdetails params
func (o *PostUIOpenwindowMarketdetailsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the post ui openwindow marketdetails params
func (o *PostUIOpenwindowMarketdetailsParams) WithContext(ctx context.Context) *PostUIOpenwindowMarketdetailsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the post ui openwindow marketdetails params
func (o *PostUIOpenwindowMarketdetailsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithDatasource adds the datasource to the post ui openwindow marketdetails params
func (o *PostUIOpenwindowMarketdetailsParams) WithDatasource(datasource *string) *PostUIOpenwindowMarketdetailsParams {
	o.SetDatasource(datasource)
	return o
}

// SetDatasource adds the datasource to the post ui openwindow marketdetails params
func (o *PostUIOpenwindowMarketdetailsParams) SetDatasource(datasource *string) {
	o.Datasource = datasource
}

// WithTypeID adds the typeID to the post ui openwindow marketdetails params
func (o *PostUIOpenwindowMarketdetailsParams) WithTypeID(typeID int32) *PostUIOpenwindowMarketdetailsParams {
	o.SetTypeID(typeID)
	return o
}

// SetTypeID adds the typeId to the post ui openwindow marketdetails params
func (o *PostUIOpenwindowMarketdetailsParams) SetTypeID(typeID int32) {
	o.TypeID = typeID
}

// WriteToRequest writes these params to a swagger request
func (o *PostUIOpenwindowMarketdetailsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	r.SetTimeout(o.timeout)
	var res []error

	if o.Datasource != nil {

		// query param datasource
		var qrDatasource string
		if o.Datasource != nil {
			qrDatasource = *o.Datasource
		}
		qDatasource := qrDatasource
		if qDatasource != "" {
			if err := r.SetQueryParam("datasource", qDatasource); err != nil {
				return err
			}
		}

	}

	// query param type_id
	qrTypeID := o.TypeID
	qTypeID := swag.FormatInt32(qrTypeID)
	if qTypeID != "" {
		if err := r.SetQueryParam("type_id", qTypeID); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
