package wars

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"
	"time"

	"golang.org/x/net/context"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/swag"

	strfmt "github.com/go-openapi/strfmt"
)

// NewGetWarsParams creates a new GetWarsParams object
// with the default values initialized.
func NewGetWarsParams() *GetWarsParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &GetWarsParams{
		Datasource: &datasourceDefault,

		timeout: cr.DefaultTimeout,
	}
}

// NewGetWarsParamsWithTimeout creates a new GetWarsParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewGetWarsParamsWithTimeout(timeout time.Duration) *GetWarsParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &GetWarsParams{
		Datasource: &datasourceDefault,

		timeout: timeout,
	}
}

// NewGetWarsParamsWithContext creates a new GetWarsParams object
// with the default values initialized, and the ability to set a context for a request
func NewGetWarsParamsWithContext(ctx context.Context) *GetWarsParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &GetWarsParams{
		Datasource: &datasourceDefault,

		Context: ctx,
	}
}

/*GetWarsParams contains all the parameters to send to the API endpoint
for the get wars operation typically these are written to a http.Request
*/
type GetWarsParams struct {

	/*Datasource
	  The server name you would like data from

	*/
	Datasource *string
	/*MaxWarID
	  Only return wars with ID smaller than this.

	*/
	MaxWarID *int32

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the get wars params
func (o *GetWarsParams) WithTimeout(timeout time.Duration) *GetWarsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get wars params
func (o *GetWarsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get wars params
func (o *GetWarsParams) WithContext(ctx context.Context) *GetWarsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get wars params
func (o *GetWarsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithDatasource adds the datasource to the get wars params
func (o *GetWarsParams) WithDatasource(datasource *string) *GetWarsParams {
	o.SetDatasource(datasource)
	return o
}

// SetDatasource adds the datasource to the get wars params
func (o *GetWarsParams) SetDatasource(datasource *string) {
	o.Datasource = datasource
}

// WithMaxWarID adds the maxWarID to the get wars params
func (o *GetWarsParams) WithMaxWarID(maxWarID *int32) *GetWarsParams {
	o.SetMaxWarID(maxWarID)
	return o
}

// SetMaxWarID adds the maxWarId to the get wars params
func (o *GetWarsParams) SetMaxWarID(maxWarID *int32) {
	o.MaxWarID = maxWarID
}

// WriteToRequest writes these params to a swagger request
func (o *GetWarsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	r.SetTimeout(o.timeout)
	var res []error

	if o.Datasource != nil {

		// query param datasource
		var qrDatasource string
		if o.Datasource != nil {
			qrDatasource = *o.Datasource
		}
		qDatasource := qrDatasource
		if qDatasource != "" {
			if err := r.SetQueryParam("datasource", qDatasource); err != nil {
				return err
			}
		}

	}

	if o.MaxWarID != nil {

		// query param max_war_id
		var qrMaxWarID int32
		if o.MaxWarID != nil {
			qrMaxWarID = *o.MaxWarID
		}
		qMaxWarID := swag.FormatInt32(qrMaxWarID)
		if qMaxWarID != "" {
			if err := r.SetQueryParam("max_war_id", qMaxWarID); err != nil {
				return err
			}
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
